## dynarmic 5.150.gea08a389+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(dynarmic LANGUAGES C CXX ASM VERSION 5)

# Determine if we're built as a subproject (using add_subdirectory)
# or if this is the master project.
set(MASTER_PROJECT OFF)
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  set(MASTER_PROJECT ON)
endif()

# Dynarmic project options
option(DYNARMIC_ENABLE_CPU_FEATURE_DETECTION "Turning this off causes dynarmic to assume the host CPU doesn't support anything later than SSE3" ON)
option(DYNARMIC_ENABLE_NO_EXECUTE_SUPPORT "Enables support for systems that require W^X" OFF)
option(DYNARMIC_FATAL_ERRORS "Errors are fatal" OFF)
option(DYNARMIC_IGNORE_ASSERTS "Ignore asserts" OFF)
option(DYNARMIC_TESTS "Build tests" ${MASTER_PROJECT})
option(DYNARMIC_TESTS_USE_UNICORN "Enable fuzzing tests against unicorn" OFF)
option(DYNARMIC_USE_LLVM "Support disassembly of jitted x86_64 code using LLVM" OFF)
option(DYNARMIC_WARNINGS_AS_ERRORS "Warnings as errors" ${MASTER_PROJECT})
if (NOT DEFINED DYNARMIC_FRONTENDS)
    set(DYNARMIC_FRONTENDS "A32;A64" CACHE STRING "Selects which frontends to enable")
endif()

# Default to a Release build
if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
    message(STATUS "Defaulting to a Release build")
endif()

# Set hard requirements for C++
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Disable in-source builds
set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
if ("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message(SEND_ERROR "In-source builds are not allowed.")
endif()

# Add the module directory to the list of paths
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeModules")

# Compiler flags
if (MSVC)
    set(DYNARMIC_CXX_FLAGS
        /std:c++latest # CMAKE_CXX_STANDARD has no effect on MSVC until CMake 3.10.
        /experimental:external
        /external:W0
        /external:anglebrackets
        /W4
        /w44263 # Non-virtual member function hides base class virtual function
        /w44265 # Class has virtual functions, but destructor is not virtual
        /w44456 # Declaration of 'var' hides previous local declaration
        /w44457 # Declaration of 'var' hides function parameter
        /w44458 # Declaration of 'var' hides class member
        /w44459 # Declaration of 'var' hides global definition
        /w44946 # Reinterpret-cast between related types
        /wd4592 # Symbol will be dynamically initialized (implementation limitation)
        /permissive- # Stricter C++ standards conformance
        /MP
        /Zi
        /Zo
        /EHsc
        /Zc:externConstexpr # Allows external linkage for variables declared "extern constexpr", as the standard permits.
        /Zc:inline          # Omits inline functions from object-file output.
        /Zc:throwingNew     # Assumes new (without std::nothrow) never returns null.
        /volatile:iso       # Use strict standard-abiding volatile semantics
        /bigobj             # Increase number of sections in .obj files
        /DNOMINMAX)

    if (DYNARMIC_WARNINGS_AS_ERRORS)
        list(APPEND DYNARMIC_CXX_FLAGS
             /WX)
    endif()

    if (CMAKE_VS_PLATFORM_TOOLSET MATCHES "LLVM-vs[0-9]+")
        list(APPEND DYNARMIC_CXX_FLAGS
             -Qunused-arguments
             -Wno-missing-braces)
    endif()
else()
    set(DYNARMIC_CXX_FLAGS
        -Wall
        -Wextra
        -Wcast-qual
        -pedantic
        -pedantic-errors
        -Wno-missing-braces)

    if (DYNARMIC_WARNINGS_AS_ERRORS)
        list(APPEND DYNARMIC_CXX_FLAGS
             -Werror)
    endif()

    if (DYNARMIC_FATAL_ERRORS)
        list(APPEND DYNARMIC_CXX_FLAGS
             -Wfatal-errors)
    endif()

    if (CMAKE_CXX_COMPILER_ID MATCHES "[Cc]lang")
        # Bracket depth determines maximum size of a fold expression in Clang since 9c9974c3ccb6.
        # And this in turns limits the size of a std::array.
        list(APPEND DYNARMIC_CXX_FLAGS -fbracket-depth=1024)
    endif()
endif()

# Arch detection
include(DetectArchitecture)
if (NOT DEFINED ARCHITECTURE)
    message(FATAL_ERROR "Unsupported architecture encountered. Ending CMake generation.")
endif()
message(STATUS "Target architecture: ${ARCHITECTURE}")

# Include Boost
if (NOT TARGET boost)
    if (NOT Boost_INCLUDE_DIRS)
        find_package(Boost 1.57.0 REQUIRED)
    endif()
    add_library(boost INTERFACE)
    target_include_directories(boost SYSTEM INTERFACE ${Boost_INCLUDE_DIRS})
endif()

if (DYNARMIC_NO_BUNDLED_FMT AND NOT TARGET fmt AND NOT TARGET fmt::fmt)
    find_package(fmt REQUIRED)
    add_library(fmt ALIAS fmt::fmt)
endif()

if (DYNARMIC_NO_BUNDLED_ROBIN_MAP AND NOT TARGET tsl::robin_map)
    find_package(tsl-robin-map REQUIRED)
endif()

if (DYNARMIC_NO_BUNDLED_XBYAK AND NOT TARGET xbyak)
    if (ARCHITECTURE STREQUAL "x86" OR ARCHITECTURE STREQUAL "x86_64")
        find_package(xbyak REQUIRED)
        add_library(xbyak ALIAS xbyak::xbyak)
    endif()
endif()

if (DYNARMIC_NO_BUNDLED_ZYDIS AND NOT TARGET Zydis)
    find_package(Zydis REQUIRED)
    add_library(Zydis ALIAS Zydis::Zydis)
endif()

# Enable unit-testing.
enable_testing(true)

# Include LLVM
if (DYNARMIC_USE_LLVM)
    find_package(LLVM REQUIRED CONFIG)
    include_directories(${LLVM_INCLUDE_DIRS})
    add_definitions(-DDYNARMIC_USE_LLVM ${LLVM_DEFINITIONS})
    llvm_map_components_to_libnames(llvm_libs armdesc armdisassembler aarch64desc aarch64disassembler x86desc x86disassembler)
endif()

if (DYNARMIC_TESTS_USE_UNICORN)
    find_package(Unicorn REQUIRED)
endif()

if (DYNARMIC_TESTS AND DYNARMIC_NO_BUNDLED_CATCH AND NOT TARGET catch)
    find_package(Catch2 REQUIRED)
    add_library(catch ALIAS Catch2::Catch2)
endif()

# Pull in externals CMakeLists for libs where available
add_subdirectory(externals)

# Dynarmic project files
add_subdirectory(src/dynarmic)
if (DYNARMIC_TESTS)
    add_subdirectory(tests)
endif()

#
# Install
#
if (MASTER_PROJECT)
    include(GNUInstallDirs)
    include(CMakePackageConfigHelpers)

    install(TARGETS dynarmic EXPORT dynarmicTargets)
    install(EXPORT dynarmicTargets
        NAMESPACE dynarmic::
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/dynarmic"
    )

    configure_package_config_file(CMakeModules/dynarmicConfig.cmake.in
        dynarmicConfig.cmake
        INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/dynarmic"
    )
    write_basic_package_version_file(dynarmicConfigVersion.cmake
        COMPATIBILITY SameMajorVersion
    )
    install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/dynarmicConfig.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/dynarmicConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/dynarmic"
    )

    install(DIRECTORY src/dynarmic TYPE INCLUDE FILES_MATCHING PATTERN "*.h")
endif()

=== externals/CMakeLists.txt ===
# Always build externals as static libraries, even when dynarmic is built as shared
set(BUILD_SHARED_LIBS OFF)

# For libraries that already come with a CMakeLists file,
# simply add the directory to that file as a subdirectory
# to have CMake automatically recognize them.

# catch

if (DYNARMIC_TESTS AND NOT TARGET catch)
    add_library(catch INTERFACE)
    target_include_directories(catch INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/catch/include>)
endif()

# fmt

if (NOT TARGET fmt AND NOT TARGET fmt::fmt)
    # fmtlib formatting library
    add_subdirectory(fmt)
endif()

# mp

add_library(mp INTERFACE)
target_include_directories(mp INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/mp/include>)

# robin-map

if (NOT TARGET tsl::robin_map)
    add_subdirectory(robin-map)
endif()

# vixl

if (ARCHITECTURE STREQUAL "arm64")
    add_subdirectory(vixl EXCLUDE_FROM_ALL)
endif()

# xbyak

if (NOT TARGET xbyak)
    if (ARCHITECTURE STREQUAL "x86" OR ARCHITECTURE STREQUAL "x86_64")
        add_library(xbyak INTERFACE)
        file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/xbyak/include)
        file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/xbyak/xbyak DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/xbyak/include)
        target_include_directories(xbyak SYSTEM INTERFACE ${CMAKE_CURRENT_BINARY_DIR}/xbyak/include)
        target_compile_definitions(xbyak INTERFACE XBYAK_NO_OP_NAMES)
    endif()
endif()

# zydis

if (NOT TARGET Zydis)
    option(ZYDIS_BUILD_TOOLS "" OFF)
    option(ZYDIS_BUILD_EXAMPLES "" OFF)
    set(ZYDIS_ZYCORE_PATH "${CMAKE_CURRENT_LIST_DIR}/zycore" CACHE PATH "")
    add_subdirectory(zydis EXCLUDE_FROM_ALL)
endif()

=== tests/CMakeLists.txt ===
if ((NOT "A32" IN_LIST DYNARMIC_FRONTENDS) OR (NOT "A64" IN_LIST DYNARMIC_FRONTENDS))
    return()
endif()

add_executable(dynarmic_tests
    A32/test_arm_disassembler.cpp
    A32/test_arm_instructions.cpp
    A32/test_thumb_instructions.cpp
    A32/testenv.h
    A64/a64.cpp
    A64/testenv.h
    cpu_info.cpp
    decoder_tests.cpp
    fp/FPToFixed.cpp
    fp/FPValue.cpp
    fp/mantissa_util_tests.cpp
    fp/unpacked_tests.cpp
    main.cpp
    rand_int.h
)

if (NOT MSVC)
    target_sources(dynarmic_tests PRIVATE
        rsqrt_test.cpp
        rsqrt_test_fn.s
    )
endif()

if (DYNARMIC_TESTS_USE_UNICORN)
    target_sources(dynarmic_tests PRIVATE
        A32/fuzz_arm.cpp
        A32/fuzz_thumb.cpp
        A64/fuzz_with_unicorn.cpp
        A64/misaligned_page_table.cpp
        A64/verify_unicorn.cpp
        fuzz_util.cpp
        fuzz_util.h
        unicorn_emu/a32_unicorn.cpp
        unicorn_emu/a32_unicorn.h
        unicorn_emu/a64_unicorn.cpp
        unicorn_emu/a64_unicorn.h
    )
    target_link_libraries(dynarmic_tests PRIVATE Unicorn::Unicorn)
endif()

add_executable(dynarmic_print_info
    print_info.cpp
)

include(CreateDirectoryGroups)
create_target_directory_groups(dynarmic_tests)
create_target_directory_groups(dynarmic_print_info)

target_link_libraries(dynarmic_tests PRIVATE dynarmic boost catch fmt mp xbyak)
target_include_directories(dynarmic_tests PRIVATE . ../src)
target_compile_options(dynarmic_tests PRIVATE ${DYNARMIC_CXX_FLAGS})
target_compile_definitions(dynarmic_tests PRIVATE FMT_USE_USER_DEFINED_LITERALS=1 CATCH_CONFIG_ENABLE_BENCHMARKING=1)

target_link_libraries(dynarmic_print_info PRIVATE dynarmic boost catch fmt mp)
target_include_directories(dynarmic_print_info PRIVATE . ../src)
target_compile_options(dynarmic_print_info PRIVATE ${DYNARMIC_CXX_FLAGS})
target_compile_definitions(dynarmic_print_info PRIVATE FMT_USE_USER_DEFINED_LITERALS=1)

add_test(dynarmic_tests dynarmic_tests --durations yes)

=== src/dynarmic/CMakeLists.txt ===
add_library(dynarmic
    common/assert.cpp
    common/assert.h
    common/bit_util.h
    common/cast_util.h
    common/common_types.h
    common/crypto/aes.cpp
    common/crypto/aes.h
    common/crypto/crc32.cpp
    common/crypto/crc32.h
    common/crypto/sm4.cpp
    common/crypto/sm4.h
    common/fp/fpcr.h
    common/fp/fpsr.h
    common/fp/fused.cpp
    common/fp/fused.h
    common/fp/info.h
    common/fp/mantissa_util.h
    common/fp/op.h
    common/fp/op/FPCompare.cpp
    common/fp/op/FPCompare.h
    common/fp/op/FPConvert.cpp
    common/fp/op/FPConvert.h
    common/fp/op/FPMulAdd.cpp
    common/fp/op/FPMulAdd.h
    common/fp/op/FPNeg.h
    common/fp/op/FPRecipEstimate.cpp
    common/fp/op/FPRecipEstimate.h
    common/fp/op/FPRecipExponent.cpp
    common/fp/op/FPRecipExponent.h
    common/fp/op/FPRecipStepFused.cpp
    common/fp/op/FPRecipStepFused.h
    common/fp/op/FPRoundInt.cpp
    common/fp/op/FPRoundInt.h
    common/fp/op/FPRSqrtEstimate.cpp
    common/fp/op/FPRSqrtEstimate.h
    common/fp/op/FPRSqrtStepFused.cpp
    common/fp/op/FPRSqrtStepFused.h
    common/fp/op/FPToFixed.cpp
    common/fp/op/FPToFixed.h
    common/fp/process_exception.cpp
    common/fp/process_exception.h
    common/fp/process_nan.cpp
    common/fp/process_nan.h
    common/fp/rounding_mode.h
    common/fp/unpacked.cpp
    common/fp/unpacked.h
    common/fp/util.h
    common/intrusive_list.h
    common/iterator_util.h
    common/llvm_disassemble.cpp
    common/llvm_disassemble.h
    common/lut_from_list.h
    common/macro_util.h
    common/math_util.cpp
    common/math_util.h
    common/memory_pool.cpp
    common/memory_pool.h
    common/safe_ops.h
    common/scope_exit.h
    common/string_util.h
    common/u128.cpp
    common/u128.h
    common/variant_util.h
    common/x64_disassemble.cpp
    common/x64_disassemble.h
    frontend/A32/a32_types.cpp
    frontend/A32/a32_types.h
    frontend/A64/a64_types.cpp
    frontend/A64/a64_types.h
    frontend/decoder/decoder_detail.h
    frontend/decoder/matcher.h
    frontend/imm.cpp
    frontend/imm.h
    interface/exclusive_monitor.h
    interface/optimization_flags.h
    ir/basic_block.cpp
    ir/basic_block.h
    ir/cond.h
    ir/ir_emitter.cpp
    ir/ir_emitter.h
    ir/location_descriptor.cpp
    ir/location_descriptor.h
    ir/microinstruction.cpp
    ir/microinstruction.h
    ir/opcodes.cpp
    ir/opcodes.h
    ir/opcodes.inc
    ir/opt/constant_propagation_pass.cpp
    ir/opt/dead_code_elimination_pass.cpp
    ir/opt/identity_removal_pass.cpp
    ir/opt/ir_matcher.h
    ir/opt/passes.h
    ir/opt/verification_pass.cpp
    ir/terminal.h
    ir/type.cpp
    ir/type.h
    ir/value.cpp
    ir/value.h
)

if ("A32" IN_LIST DYNARMIC_FRONTENDS)
    target_sources(dynarmic PRIVATE
        frontend/A32/decoder/arm.h
        frontend/A32/decoder/arm.inc
        frontend/A32/decoder/asimd.h
        frontend/A32/decoder/asimd.inc
        frontend/A32/decoder/thumb16.h
        frontend/A32/decoder/thumb16.inc
        frontend/A32/decoder/thumb32.h
        frontend/A32/decoder/thumb32.inc
        frontend/A32/decoder/vfp.h
        frontend/A32/decoder/vfp.inc
        frontend/A32/disassembler/disassembler.h
        frontend/A32/disassembler/disassembler_arm.cpp
        frontend/A32/disassembler/disassembler_thumb.cpp
        frontend/A32/FPSCR.h
        frontend/A32/a32_ir_emitter.cpp
        frontend/A32/a32_ir_emitter.h
        frontend/A32/a32_location_descriptor.cpp
        frontend/A32/a32_location_descriptor.h
        frontend/A32/ITState.h
        frontend/A32/PSR.h
        frontend/A32/translate/a32_translate.cpp
        frontend/A32/translate/a32_translate.h
        frontend/A32/translate/impl/a32_branch.cpp
        frontend/A32/translate/impl/a32_crc32.cpp
        frontend/A32/translate/impl/a32_exception_generating.cpp
        frontend/A32/translate/impl/a32_translate_impl.cpp
        frontend/A32/translate/impl/a32_translate_impl.h
        frontend/A32/translate/conditional_state.cpp
        frontend/A32/translate/conditional_state.h
        frontend/A32/translate/impl/asimd_load_store_structures.cpp
        frontend/A32/translate/impl/asimd_misc.cpp
        frontend/A32/translate/impl/asimd_one_reg_modified_immediate.cpp
        frontend/A32/translate/impl/asimd_three_regs.cpp
        frontend/A32/translate/impl/asimd_two_regs_misc.cpp
        frontend/A32/translate/impl/asimd_two_regs_scalar.cpp
        frontend/A32/translate/impl/asimd_two_regs_shift.cpp
        frontend/A32/translate/impl/barrier.cpp
        frontend/A32/translate/impl/coprocessor.cpp
        frontend/A32/translate/impl/data_processing.cpp
        frontend/A32/translate/impl/divide.cpp
        frontend/A32/translate/impl/extension.cpp
        frontend/A32/translate/impl/hint.cpp
        frontend/A32/translate/impl/load_store.cpp
        frontend/A32/translate/impl/misc.cpp
        frontend/A32/translate/impl/multiply.cpp
        frontend/A32/translate/impl/packing.cpp
        frontend/A32/translate/impl/parallel.cpp
        frontend/A32/translate/impl/reversal.cpp
        frontend/A32/translate/impl/saturated.cpp
        frontend/A32/translate/impl/status_register_access.cpp
        frontend/A32/translate/impl/synchronization.cpp
        frontend/A32/translate/impl/thumb16.cpp
        frontend/A32/translate/impl/thumb32_branch.cpp
        frontend/A32/translate/impl/thumb32_control.cpp
        frontend/A32/translate/impl/thumb32_coprocessor.cpp
        frontend/A32/translate/impl/thumb32_data_processing_modified_immediate.cpp
        frontend/A32/translate/impl/thumb32_data_processing_plain_binary_immediate.cpp
        frontend/A32/translate/impl/thumb32_data_processing_register.cpp
        frontend/A32/translate/impl/thumb32_data_processing_shifted_register.cpp
        frontend/A32/translate/impl/thumb32_load_byte.cpp
        frontend/A32/translate/impl/thumb32_load_halfword.cpp
        frontend/A32/translate/impl/thumb32_load_store_dual.cpp
        frontend/A32/translate/impl/thumb32_load_store_multiple.cpp
        frontend/A32/translate/impl/thumb32_load_word.cpp
        frontend/A32/translate/impl/thumb32_long_multiply.cpp
        frontend/A32/translate/impl/thumb32_misc.cpp
        frontend/A32/translate/impl/thumb32_multiply.cpp
        frontend/A32/translate/impl/thumb32_parallel.cpp
        frontend/A32/translate/impl/thumb32_store_single_data_item.cpp
        frontend/A32/translate/impl/vfp.cpp
        frontend/A32/translate/translate_arm.cpp
        frontend/A32/translate/translate_thumb.cpp
        interface/A32/a32.h
        interface/A32/arch_version.h
        interface/A32/config.h
        interface/A32/coprocessor.h
        interface/A32/coprocessor_util.h
        interface/A32/disassembler.h
        ir/opt/a32_constant_memory_reads_pass.cpp
        ir/opt/a32_get_set_elimination_pass.cpp
    )
endif()

if ("A64" IN_LIST DYNARMIC_FRONTENDS)
    target_sources(dynarmic PRIVATE
        frontend/A64/a64_ir_emitter.cpp
        frontend/A64/a64_ir_emitter.h
        frontend/A64/a64_location_descriptor.cpp
        frontend/A64/a64_location_descriptor.h
        frontend/A64/decoder/a64.h
        frontend/A64/decoder/a64.inc
        frontend/A64/translate/a64_translate.cpp
        frontend/A64/translate/a64_translate.h
        frontend/A64/translate/impl/a64_branch.cpp
        frontend/A64/translate/impl/a64_exception_generating.cpp
        frontend/A64/translate/impl/data_processing_addsub.cpp
        frontend/A64/translate/impl/data_processing_bitfield.cpp
        frontend/A64/translate/impl/data_processing_conditional_compare.cpp
        frontend/A64/translate/impl/data_processing_conditional_select.cpp
        frontend/A64/translate/impl/data_processing_crc32.cpp
        frontend/A64/translate/impl/data_processing_logical.cpp
        frontend/A64/translate/impl/data_processing_multiply.cpp
        frontend/A64/translate/impl/data_processing_pcrel.cpp
        frontend/A64/translate/impl/data_processing_register.cpp
        frontend/A64/translate/impl/data_processing_shift.cpp
        frontend/A64/translate/impl/floating_point_compare.cpp
        frontend/A64/translate/impl/floating_point_conditional_compare.cpp
        frontend/A64/translate/impl/floating_point_conditional_select.cpp
        frontend/A64/translate/impl/floating_point_conversion_fixed_point.cpp
        frontend/A64/translate/impl/floating_point_conversion_integer.cpp
        frontend/A64/translate/impl/floating_point_data_processing_one_register.cpp
        frontend/A64/translate/impl/floating_point_data_processing_three_register.cpp
        frontend/A64/translate/impl/floating_point_data_processing_two_register.cpp
        frontend/A64/translate/impl/impl.cpp
        frontend/A64/translate/impl/impl.h
        frontend/A64/translate/impl/load_store_exclusive.cpp
        frontend/A64/translate/impl/load_store_load_literal.cpp
        frontend/A64/translate/impl/load_store_multiple_structures.cpp
        frontend/A64/translate/impl/load_store_no_allocate_pair.cpp
        frontend/A64/translate/impl/load_store_register_immediate.cpp
        frontend/A64/translate/impl/load_store_register_pair.cpp
        frontend/A64/translate/impl/load_store_register_register_offset.cpp
        frontend/A64/translate/impl/load_store_register_unprivileged.cpp
        frontend/A64/translate/impl/load_store_single_structure.cpp
        frontend/A64/translate/impl/move_wide.cpp
        frontend/A64/translate/impl/simd_across_lanes.cpp
        frontend/A64/translate/impl/simd_aes.cpp
        frontend/A64/translate/impl/simd_copy.cpp
        frontend/A64/translate/impl/simd_crypto_four_register.cpp
        frontend/A64/translate/impl/simd_crypto_three_register.cpp
        frontend/A64/translate/impl/simd_extract.cpp
        frontend/A64/translate/impl/simd_modified_immediate.cpp
        frontend/A64/translate/impl/simd_permute.cpp
        frontend/A64/translate/impl/simd_scalar_pairwise.cpp
        frontend/A64/translate/impl/simd_scalar_shift_by_immediate.cpp
        frontend/A64/translate/impl/simd_scalar_three_same.cpp
        frontend/A64/translate/impl/simd_scalar_two_register_misc.cpp
        frontend/A64/translate/impl/simd_scalar_x_indexed_element.cpp
        frontend/A64/translate/impl/simd_sha.cpp
        frontend/A64/translate/impl/simd_sha512.cpp
        frontend/A64/translate/impl/simd_shift_by_immediate.cpp
        frontend/A64/translate/impl/simd_table_lookup.cpp
        frontend/A64/translate/impl/simd_three_different.cpp
        frontend/A64/translate/impl/simd_three_same.cpp
        frontend/A64/translate/impl/simd_three_same_extra.cpp
        frontend/A64/translate/impl/simd_two_register_misc.cpp
        frontend/A64/translate/impl/simd_vector_x_indexed_element.cpp
        frontend/A64/translate/impl/sys_dc.cpp
        frontend/A64/translate/impl/sys_ic.cpp
        frontend/A64/translate/impl/system.cpp
        frontend/A64/translate/impl/system_flag_format.cpp
        frontend/A64/translate/impl/system_flag_manipulation.cpp
        interface/A64/a64.h
        interface/A64/config.h
        ir/opt/a64_callback_config_pass.cpp
        ir/opt/a64_get_set_elimination_pass.cpp
        ir/opt/a64_merge_interpret_blocks.cpp
    )
endif()

if (ARCHITECTURE STREQUAL "x86_64")
    target_sources(dynarmic PRIVATE
        backend/x64/abi.cpp
        backend/x64/abi.h
        backend/x64/block_of_code.cpp
        backend/x64/block_of_code.h
        backend/x64/block_range_information.cpp
        backend/x64/block_range_information.h
        backend/x64/callback.cpp
        backend/x64/callback.h
        backend/x64/constant_pool.cpp
        backend/x64/constant_pool.h
        backend/x64/constants.h
        backend/x64/devirtualize.h
        backend/x64/emit_x64.cpp
        backend/x64/emit_x64.h
        backend/x64/emit_x64_aes.cpp
        backend/x64/emit_x64_crc32.cpp
        backend/x64/emit_x64_data_processing.cpp
        backend/x64/emit_x64_floating_point.cpp
        backend/x64/emit_x64_packed.cpp

=== debian/changelog ===
dynarmic (5.150.gea08a389+ds-1) unstable; urgency=medium

  * New upstream version 5.150.gea08a389+ds
  * d/tests: add autopkgtests

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 24 Feb 2022 13:42:50 +0100

dynarmic (5.135.g0cafcc1a+ds-1) unstable; urgency=medium

  * New upstream version 5.135.g0cafcc1a. Closes: #1003468

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 12 Jan 2022 22:27:23 +0100

dynarmic (5.132.gad5465d6+ds-1) unstable; urgency=medium

  * New upstream release.
  * d/control: depend on xbyak also on x32
  * d/control: add Vcs fields
  * d/watch: follow upstream master branch

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 03 Jan 2022 18:24:43 +0100

dynarmic (5.128.g4dcebc18+ds-1) unstable; urgency=low

  * Initial release. Closes: #995917

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 14 Nov 2021 12:35:09 +0100

=== debian/control ===
Source: dynarmic
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: debhelper-compat (= 13),
               cmake (>= 3.8),
               catch2,
               libboost-dev,
               libfmt-dev,
               libvixl-dev [arm64],
               libxbyak-dev [any-amd64],
               libzydis-dev,
               pkg-config,
               robin-map-dev
Standards-Version: 4.6.0
Homepage: https://github.com/merryhime/dynarmic
Vcs-Git: https://salsa.debian.org/tachi/dynarmic.git
Vcs-Browser: https://salsa.debian.org/tachi/dynarmic
Rules-Requires-Root: no

Package: libdynarmic5
Architecture: any-amd64
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: ARM dynamic recompiler
 Dynarmic is a dynamic recompiler for the ARMv6K, ARMv7A architecture, with
 partial ARMv8 support.
 .
 In the pursuit of speed, some behavior not commonly depended upon is elided.
 Therefore this emulator does not match spec.
 .
 This package contains the shared library.

Package: libdynarmic-dev
Section: libdevel
Architecture: any-amd64
Depends: libdynarmic5 (= ${binary:Version}), ${misc:Depends}
Description: ARM dynamic recompiler - development
 Dynarmic is a dynamic recompiler for the ARMv6K, ARMv7A architecture, with
 partial ARMv8 support.
 .
 In the pursuit of speed, some behavior not commonly depended upon is elided.
 Therefore this emulator does not match spec.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all qa=+all
export LC_ALL = C.UTF-8

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DDYNARMIC_IGNORE_ASSERTS=ON \
		-DDYNARMIC_NO_BUNDLED_CATCH=ON \
		-DDYNARMIC_NO_BUNDLED_FMT=ON \
		-DDYNARMIC_NO_BUNDLED_ROBIN_MAP=ON \
		-DDYNARMIC_NO_BUNDLED_VIXL=ON \
		-DDYNARMIC_NO_BUNDLED_XBYAK=ON \
		-DDYNARMIC_NO_BUNDLED_ZYDIS=ON

=== debian/tests/control ===
Tests: cmake
Depends: @, cmake, g++ | c++-compiler

=== debian/watch ===
# Currently tracking upstream master
#version=4
#opts="filenamemangle=s/.+\/r@ANY_VERSION@\.tar\.gz/@PACKAGE@-$1\.tar\.gz/, \
#  pgpmode=none, \
#  repacksuffix=+ds, \
#  dversionmangle=auto" \
#https://github.com/merryhime/dynarmic/tags .*/r@ANY_VERSION@\.tar\.gz

version=4
opts="mode=git, \
  pgpmode=none, \
  pretty=describe, \
  repacksuffix=+ds, \
  dversionmangle=auto, \
  uversionmangle=s/r@ANY_VERSION@/$1/" \
https://github.com/merryhime/dynarmic.git \
HEAD debian uupdate

## dynarmic 6.2.3%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.8)
-project(dynarmic LANGUAGES C CXX ASM VERSION 5)
+project(dynarmic LANGUAGES C CXX ASM VERSION 6.2.3)
 
 # Determine if we're built as a subproject (using add_subdirectory)
 # or if this is the master project.
@@ -154,7 +154,7 @@
     llvm_map_components_to_libnames(llvm_libs armdesc armdisassembler aarch64desc aarch64disassembler x86desc x86disassembler)
 endif()
 
-if (DYNARMIC_TESTS_USE_UNICORN)
+if (DYNARMIC_TESTS_USE_UNICORN AND DYNARMIC_TESTS)
     find_package(Unicorn REQUIRED)
 endif()

=== externals/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,8 @@
 # Always build externals as static libraries, even when dynarmic is built as shared
-set(BUILD_SHARED_LIBS OFF)
+if (BUILD_SHARED_LIBS)
+    set(BUILD_SHARED_LIBS OFF)
+    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
+endif()
 
 # For libraries that already come with a CMakeLists file,
 # simply add the directory to that file as a subdirectory
@@ -19,21 +22,24 @@
     add_subdirectory(fmt)
 endif()
 
-# mp
+# mcl
 
-add_library(mp INTERFACE)
-target_include_directories(mp INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/mp/include>)
+if (NOT TARGET merry::mcl)
+    add_subdirectory(mcl)
+endif()
+
+# oaknut
+
+if (NOT TARGET merry::oaknut)
+    if (ARCHITECTURE STREQUAL "arm64")
+        add_subdirectory(oaknut)
+    endif()
+endif()
 
 # robin-map
 
 if (NOT TARGET tsl::robin_map)
     add_subdirectory(robin-map)
-endif()
-
-# vixl
-
-if (ARCHITECTURE STREQUAL "arm64")
-    add_subdirectory(vixl EXCLUDE_FROM_ALL)
 endif()
 
 # xbyak

=== tests/CMakeLists.txt ===
add_executable(dynarmic_tests
    fp/FPToFixed.cpp
    fp/FPValue.cpp
    fp/mantissa_util_tests.cpp
    fp/unpacked_tests.cpp
    main.cpp
    rand_int.h
)

if ("A32" IN_LIST DYNARMIC_FRONTENDS)
    target_sources(dynarmic_tests PRIVATE
        A32/test_arm_disassembler.cpp
        A32/test_arm_instructions.cpp
        A32/test_thumb_instructions.cpp
        A32/testenv.h
        decoder_tests.cpp
    )
endif()

if ("A64" IN_LIST DYNARMIC_FRONTENDS)
    target_sources(dynarmic_tests PRIVATE
        A64/a64.cpp
        A64/misaligned_page_table.cpp
        A64/test_invalidation.cpp
        A64/testenv.h
    )
endif()

if (DYNARMIC_TESTS_USE_UNICORN)
    target_link_libraries(dynarmic_tests PRIVATE Unicorn::Unicorn)

    target_sources(dynarmic_tests PRIVATE
        fuzz_util.cpp
        fuzz_util.h
    )

    if ("A32" IN_LIST DYNARMIC_FRONTENDS)
        target_sources(dynarmic_tests PRIVATE
            A32/fuzz_arm.cpp
            A32/fuzz_thumb.cpp
            unicorn_emu/a32_unicorn.cpp
            unicorn_emu/a32_unicorn.h
        )
    endif()

    if ("A64" IN_LIST DYNARMIC_FRONTENDS)
        target_sources(dynarmic_tests PRIVATE
            A64/fuzz_with_unicorn.cpp
            A64/verify_unicorn.cpp
            unicorn_emu/a64_unicorn.cpp
            unicorn_emu/a64_unicorn.h
        )
    endif()
endif()

if (ARCHITECTURE STREQUAL "x86_64")
    target_link_libraries(dynarmic_tests PRIVATE xbyak)

    target_sources(dynarmic_tests PRIVATE
        x64_cpu_info.cpp
    )

    if (NOT MSVC)
        target_sources(dynarmic_tests PRIVATE
            rsqrt_test.cpp
            rsqrt_test_fn.s
        )
    endif()
endif()

include(CreateDirectoryGroups)

if (("A32" IN_LIST DYNARMIC_FRONTENDS) AND ("A64" IN_LIST DYNARMIC_FRONTENDS))
    add_executable(dynarmic_print_info
        print_info.cpp
    )

    create_target_directory_groups(dynarmic_print_info)

    target_link_libraries(dynarmic_print_info PRIVATE dynarmic boost catch fmt)
    target_include_directories(dynarmic_print_info PRIVATE . ../src)
    target_compile_options(dynarmic_print_info PRIVATE ${DYNARMIC_CXX_FLAGS})
    target_compile_definitions(dynarmic_print_info PRIVATE FMT_USE_USER_DEFINED_LITERALS=1)
endif()

create_target_directory_groups(dynarmic_tests)

target_link_libraries(dynarmic_tests PRIVATE dynarmic boost catch fmt)
target_include_directories(dynarmic_tests PRIVATE . ../src)
target_compile_options(dynarmic_tests PRIVATE ${DYNARMIC_CXX_FLAGS})
target_compile_definitions(dynarmic_tests PRIVATE FMT_USE_USER_DEFINED_LITERALS=1 CATCH_CONFIG_ENABLE_BENCHMARKING=1)

add_test(dynarmic_tests dynarmic_tests --durations yes)

=== externals/oaknut/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(oaknut LANGUAGES CXX VERSION 0.0.0)

# Determine if we're built as a subproject (using add_subdirectory)
# or if this is the master project.
set(MASTER_PROJECT OFF)
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  set(MASTER_PROJECT ON)
endif()

# Disable in-source builds
set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
if ("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message(SEND_ERROR "In-source builds are not allowed.")
endif()

# Source project files
set(header_files
    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/arm64_encode_helpers.inc.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/arm64_mnemonics.inc.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/enum.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/fpsimd_mnemonics.inc.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/imm.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/list.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/multi_typed_name.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/offset.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/reg.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/string_literal.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/oaknut.hpp
)

# Library definition
add_library(oaknut INTERFACE)
add_library(merry::oaknut ALIAS oaknut)
target_sources(oaknut INTERFACE "$<BUILD_INTERFACE:${header_files}>")
target_include_directories(oaknut INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>)
target_compile_features(oaknut INTERFACE cxx_std_20)

# Tests
if (MASTER_PROJECT)
    if (DYNARMIC_USE_BUNDLED_CATCH)
        add_subdirectory(externals/catch)
    else()
        find_package(Catch2 3 REQUIRED)
    endif()

    add_executable(oaknut-tests
        tests/basic.cpp
        tests/fpsimd.cpp
        tests/general.cpp
    )
    target_include_directories(oaknut-tests PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/tests)
    target_link_libraries(oaknut-tests PRIVATE Catch2::Catch2WithMain merry::oaknut)
    target_compile_options(oaknut-tests PRIVATE -Wall -Wextra -Wcast-qual -pedantic -pedantic-errors -Wfatal-errors -Wno-missing-braces)
endif()

=== src/dynarmic/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,5 @@
 add_library(dynarmic
-    common/assert.cpp
-    common/assert.h
-    common/bit_util.h
     common/cast_util.h
-    common/common_types.h
     common/crypto/aes.cpp
     common/crypto/aes.h
     common/crypto/crc32.cpp
@@ -46,24 +42,19 @@
     common/fp/unpacked.cpp
     common/fp/unpacked.h
     common/fp/util.h
-    common/intrusive_list.h
-    common/iterator_util.h
     common/llvm_disassemble.cpp
     common/llvm_disassemble.h
     common/lut_from_list.h
-    common/macro_util.h
     common/math_util.cpp
     common/math_util.h
     common/memory_pool.cpp
     common/memory_pool.h
     common/safe_ops.h
-    common/scope_exit.h
+    common/spin_lock.h
     common/string_util.h
     common/u128.cpp
     common/u128.h
     common/variant_util.h
-    common/x64_disassemble.cpp
-    common/x64_disassemble.h
     frontend/A32/a32_types.cpp
     frontend/A32/a32_types.h
     frontend/A64/a64_types.cpp
@@ -74,6 +65,7 @@
     frontend/imm.h
     interface/exclusive_monitor.h
     interface/optimization_flags.h
+    ir/acc_type.h
     ir/basic_block.cpp
     ir/basic_block.h
     ir/cond.h
@@ -91,6 +83,7 @@
     ir/opt/identity_removal_pass.cpp
     ir/opt/ir_matcher.h
     ir/opt/passes.h
+    ir/opt/polyfill_pass.cpp
     ir/opt/verification_pass.cpp
     ir/terminal.h
     ir/type.cpp
@@ -262,6 +255,12 @@
 endif()
 
 if (ARCHITECTURE STREQUAL "x86_64")
+    target_link_libraries(dynarmic
+        PRIVATE
+            $<BUILD_INTERFACE:xbyak>
+            $<BUILD_INTERFACE:Zydis>
+    )
+
     target_sources(dynarmic PRIVATE
         backend/x64/abi.cpp
         backend/x64/abi.h
@@ -281,4 +280,5 @@
         backend/x64/emit_x64_crc32.cpp
         backend/x64/emit_x64_data_processing.cpp
         backend/x64/emit_x64_floating_point.cpp
-        backend/x64/emit_x64_packed.cpp
+        backend/x64/emit_x64_memory.h
+        backend/x64/emit_x64_memory.cpp.inc

## dynarmic 6.2.3+ds

=== debian/changelog ===
dynarmic (6.2.3+ds-1build1) kinetic; urgency=medium

  * No-change rebuild against libfmt9

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 21 Aug 2022 06:04:10 +0000

dynarmic (6.2.3+ds-1) unstable; urgency=medium

  * New upstream version 6.2.3+ds
    - fmtlib 9.0.0 is now supported. Closes: #1014674

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 28 Jul 2022 12:50:19 +0200

dynarmic (6.2.1+ds-1) unstable; urgency=medium

  * New upstream version 6.2.1+ds

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sat, 23 Jul 2022 17:08:36 +0200

dynarmic (6.0.0+ds-1) unstable; urgency=medium

  * New upstream version 6.0.0+ds
  * d/watch: track stable releases

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 22 Jun 2022 16:19:53 +0200

dynarmic (5.204.g57af72a5+ds-1) unstable; urgency=medium

  * New upstream version 5.204.g57af72a5+ds

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 19 Apr 2022 23:06:39 +0200

dynarmic (5.196.g27bbf450+ds-1) unstable; urgency=medium

  * New upstream version 5.196.g27bbf450+ds
  * d/rules: use CMake LTO instead of dpkg-buildflags'

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 18 Apr 2022 20:11:00 +0200

dynarmic (5.187.g9cadab8f+ds-1) unstable; urgency=medium

  * New upstream version 5.187.g9cadab8f+ds

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 30 Mar 2022 21:39:23 +0200

dynarmic (5.163.ge4b669fd+ds-1) unstable; urgency=medium

  [ Bastian Germann ]
  * Move Vcs-* fields to debian namespace

  [ Andrea Pappacoda ]
  * New upstream version 5.163.ge4b669fd+ds
  * d/patches: remove upstreamed patches

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 13 Mar 2022 22:11:31 +0100

=== debian/control ===
Source: dynarmic
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: debhelper-compat (= 13),
               cmake (>= 3.8),
               catch2,
               libboost-dev,
               libfmt-dev,
               libvixl-dev [arm64],
               libxbyak-dev [any-amd64],
               libzydis-dev,
               pkg-config,
               robin-map-dev
Standards-Version: 4.6.0
Homepage: https://github.com/merryhime/dynarmic
Vcs-Git: https://salsa.debian.org/debian/dynarmic.git
Vcs-Browser: https://salsa.debian.org/debian/dynarmic
Rules-Requires-Root: no
Description: ARM dynamic recompiler
 Dynarmic is a dynamic recompiler for the ARMv6K, ARMv7A architecture, with
 partial ARMv8 support.
 .
 In the pursuit of speed, some behavior not commonly depended upon is elided.
 Therefore this emulator does not match spec.

Package: libdynarmic6
Architecture: any-amd64
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package contains the shared library.

Package: libdynarmic-dev
Section: libdevel
Architecture: any-amd64
Depends: libdynarmic6 (= ${binary:Version}), ${misc:Depends}
Description: ${source:Synopsis} - development
 ${source:Extended-Description}
 .
 This package contains the development files.

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,9 @@
 #!/usr/bin/make -f
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all qa=+all
-export LC_ALL = C.UTF-8
+# optimize=+all,-lto because I use CMake's LTO support
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+all,-lto qa=+all
+# Added by qa=bug, triggers some false positives in xbyak
+export DEB_CXXFLAGS_MAINT_STRIP = -Werror=array-bounds
 
 %:
 	dh $@
@@ -15,4 +17,6 @@
 		-DDYNARMIC_NO_BUNDLED_ROBIN_MAP=ON \
 		-DDYNARMIC_NO_BUNDLED_VIXL=ON \
 		-DDYNARMIC_NO_BUNDLED_XBYAK=ON \
-		-DDYNARMIC_NO_BUNDLED_ZYDIS=ON
+		-DDYNARMIC_NO_BUNDLED_ZYDIS=ON \
+		-DCMAKE_INTERPROCEDURAL_OPTIMIZATION=ON \
+		-DCMAKE_POLICY_DEFAULT_CMP0069=NEW

## dynarmic 6.3.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
-cmake_minimum_required(VERSION 3.8)
-project(dynarmic LANGUAGES C CXX ASM VERSION 6.2.3)
+cmake_minimum_required(VERSION 3.12)
+project(dynarmic LANGUAGES C CXX ASM VERSION 6.3.0)
 
 # Determine if we're built as a subproject (using add_subdirectory)
 # or if this is the master project.
@@ -45,7 +45,6 @@
 # Compiler flags
 if (MSVC)
     set(DYNARMIC_CXX_FLAGS
-        /std:c++latest # CMAKE_CXX_STANDARD has no effect on MSVC until CMake 3.10.
         /experimental:external
         /external:W0
         /external:anglebrackets

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,7 @@
     target_sources(dynarmic_tests PRIVATE
         A32/test_arm_disassembler.cpp
         A32/test_arm_instructions.cpp
+        A32/test_coprocessor.cpp
         A32/test_thumb_instructions.cpp
         A32/testenv.h
         decoder_tests.cpp
@@ -83,6 +84,21 @@
     target_compile_definitions(dynarmic_print_info PRIVATE FMT_USE_USER_DEFINED_LITERALS=1)
 endif()
 
+if ("A32" IN_LIST DYNARMIC_FRONTENDS)
+    add_executable(dynarmic_test_generator
+        fuzz_util.cpp
+        fuzz_util.h
+        test_generator.cpp
+    )
+
+    create_target_directory_groups(dynarmic_test_generator)
+
+    target_link_libraries(dynarmic_test_generator PRIVATE dynarmic boost catch fmt)
+    target_include_directories(dynarmic_test_generator PRIVATE . ../src)
+    target_compile_options(dynarmic_test_generator PRIVATE ${DYNARMIC_CXX_FLAGS})
+    target_compile_definitions(dynarmic_test_generator PRIVATE FMT_USE_USER_DEFINED_LITERALS=1)
+endif()
+
 create_target_directory_groups(dynarmic_tests)
 
 target_link_libraries(dynarmic_tests PRIVATE dynarmic boost catch fmt)

=== externals/oaknut/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.8)
-project(oaknut LANGUAGES CXX VERSION 0.0.0)
+project(oaknut LANGUAGES CXX VERSION 1.1.3)
 
 # Determine if we're built as a subproject (using add_subdirectory)
 # or if this is the master project.
@@ -18,11 +18,13 @@
 # Source project files
 set(header_files
     ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/arm64_encode_helpers.inc.hpp
-    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/arm64_mnemonics.inc.hpp
     ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/enum.hpp
-    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/fpsimd_mnemonics.inc.hpp
     ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/imm.hpp
     ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/list.hpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/mnemonics_fpsimd_v8.0.inc.hpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/mnemonics_fpsimd_v8.1.inc.hpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/mnemonics_generic_v8.0.inc.hpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/mnemonics_generic_v8.1.inc.hpp
     ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/multi_typed_name.hpp
     ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/offset.hpp
     ${CMAKE_CURRENT_SOURCE_DIR}/include/oaknut/impl/reg.hpp
@@ -39,7 +41,8 @@
 
 # Tests
 if (MASTER_PROJECT)
-    if (DYNARMIC_USE_BUNDLED_CATCH)
+    option(OAKNUT_USE_BUNDLED_CATCH "Use the embedded Catch2 submodule" OFF)
+    if (OAKNUT_USE_BUNDLED_CATCH)
         add_subdirectory(externals/catch)
     else()
         find_package(Catch2 3 REQUIRED)
@@ -52,5 +55,33 @@
     )
     target_include_directories(oaknut-tests PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/tests)
     target_link_libraries(oaknut-tests PRIVATE Catch2::Catch2WithMain merry::oaknut)
-    target_compile_options(oaknut-tests PRIVATE -Wall -Wextra -Wcast-qual -pedantic -pedantic-errors -Wfatal-errors -Wno-missing-braces)
+    if (MSVC)
+        target_compile_options(oaknut-tests PRIVATE
+            /experimental:external
+            /external:W0
+            /external:anglebrackets
+            /W4
+            /w44263 # Non-virtual member function hides base class virtual function
+            /w44265 # Class has virtual functions, but destructor is not virtual
+            /w44456 # Declaration of 'var' hides previous local declaration
+            /w44457 # Declaration of 'var' hides function parameter
+            /w44458 # Declaration of 'var' hides class member
+            /w44459 # Declaration of 'var' hides global definition
+            /w44946 # Reinterpret-cast between related types
+            /wd4592 # Symbol will be dynamically initialized (implementation limitation)
+            /permissive- # Stricter C++ standards conformance
+            /MP
+            /Zi
+            /Zo
+            /EHsc
+            /Zc:externConstexpr # Allows external linkage for variables declared "extern constexpr", as the standard permits.
+            /Zc:inline          # Omits inline functions from object-file output.
+            /Zc:throwingNew     # Assumes new (without std::nothrow) never returns null.
+            /volatile:iso       # Use strict standard-abiding volatile semantics
+            /bigobj             # Increase number of sections in .obj files
+            /DNOMINMAX
+        )
+    else()
+        target_compile_options(oaknut-tests PRIVATE -Wall -Wextra -Wcast-qual -pedantic -pedantic-errors -Wfatal-errors -Wno-missing-braces)
+    endif()
 endif()

=== debian/changelog ===
dynarmic (6.3.0+ds-2) unstable; urgency=medium

  * d/rules: fix arm64 build

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 22 Nov 2022 09:48:48 +0100

dynarmic (6.3.0+ds-1) unstable; urgency=medium

  * New upstream version 6.3.0+ds
  * d/control: build on arm64
  * d/copyright: remove vixl from Files-Excluded

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 20 Nov 2022 01:38:12 +0100

=== debian/control ===
Source: dynarmic
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: debhelper-compat (= 13),
               cmake (>= 3.12),
               catch2,
               libboost-dev,
               libfmt-dev,
               libxbyak-dev [any-amd64],
               libzydis-dev,
               pkg-config,
               robin-map-dev
Standards-Version: 4.6.1
Homepage: https://github.com/merryhime/dynarmic
Vcs-Git: https://salsa.debian.org/debian/dynarmic.git
Vcs-Browser: https://salsa.debian.org/debian/dynarmic
Rules-Requires-Root: no
Description: ARM dynamic recompiler
 Dynarmic is a dynamic recompiler for the ARMv6K, ARMv7A architecture, with
 partial ARMv8 support.
 .
 In the pursuit of speed, some behavior not commonly depended upon is elided.
 Therefore this emulator does not match spec.

Package: libdynarmic6
Architecture: any-amd64 any-arm64
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package contains the shared library.

Package: libdynarmic-dev
Section: libdevel
Architecture: any-amd64 any-arm64
Depends: libdynarmic6 (= ${binary:Version}), ${misc:Depends}
Description: ${source:Synopsis} - development
 ${source:Extended-Description}
 .
 This package contains the development files.

=== debian/rules ===
--- 
+++ 
@@ -8,15 +8,26 @@
 %:
 	dh $@
 
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+  test := true
+else
+  test := false
+endif
+
+ifeq ($(DEB_HOST_ARCH), arm64)
+  extra_args := -DDYNARMIC_FRONTENDS=A32
+endif
+
 override_dh_auto_configure:
 	dh_auto_configure -- \
 		-DBUILD_SHARED_LIBS=ON \
+		-DCMAKE_INTERPROCEDURAL_OPTIMIZATION=ON \
+		-DCMAKE_POLICY_DEFAULT_CMP0069=NEW \
 		-DDYNARMIC_IGNORE_ASSERTS=ON \
 		-DDYNARMIC_NO_BUNDLED_CATCH=ON \
 		-DDYNARMIC_NO_BUNDLED_FMT=ON \
 		-DDYNARMIC_NO_BUNDLED_ROBIN_MAP=ON \
-		-DDYNARMIC_NO_BUNDLED_VIXL=ON \
 		-DDYNARMIC_NO_BUNDLED_XBYAK=ON \
 		-DDYNARMIC_NO_BUNDLED_ZYDIS=ON \
-		-DCMAKE_INTERPROCEDURAL_OPTIMIZATION=ON \
-		-DCMAKE_POLICY_DEFAULT_CMP0069=NEW
+		-DDYNARMIC_TESTS=$(test) \
+		$(extra_args)

## dynarmic 6.3.1+ds

=== debian/changelog ===
dynarmic (6.3.1+ds-2) unstable; urgency=medium

  * d/control: depend on Zydis 4.0.0 or newer

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 24 Nov 2022 11:21:59 +0100

dynarmic (6.3.1+ds-1) unstable; urgency=medium

  * New upstream version 6.3.1+ds

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 23 Nov 2022 22:09:18 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                libboost-dev,
                libfmt-dev,
                libxbyak-dev [any-amd64],
-               libzydis-dev,
+               libzydis-dev (>= 4.0.0),
                pkg-config,
                robin-map-dev
 Standards-Version: 4.6.1
